<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/movedata.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>movedata.c</h1><a href="movedata_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: movedata.c 3054 2010-04-15 17:03:46Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="movedata_8c.html#aac2a4c334ae5c2baef33867114fe8006">00030</a> <span class="keywordtype">int</span> <a class="code" href="init_8h.html#aac2a4c334ae5c2baef33867114fe8006">DataMoveData</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   <span class="keywordtype">int</span> rank,size;
<a name="l00035"></a>00035   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00036"></a>00036   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="keywordflow">if</span> (size==1) {
<a name="l00039"></a>00039 <span class="preprocessor">#ifdef HAVE_ELEVERTALL</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>    gdata-&gt;elevertall=gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>;
<a name="l00041"></a>00041 <span class="preprocessor">#endif</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>
<a name="l00043"></a>00043     <span class="keywordtype">int</span> *ia,*ja;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045     ierr = <a class="code" href="mesh2dual_8c.html#abb99aec57817a85ad1c4c2552f695434">Mesh2Nodal</a>(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,&amp;ia,&amp;ja);CHKERRQ(ierr);
<a name="l00046"></a>00046     gdata-&gt;mesh2nodal_ia=ia;
<a name="l00047"></a>00047     gdata-&gt;mesh2nodal_ja=ja;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049     ierr = <a class="code" href="mesh2dual_8c.html#a072403ed5e4bbd16fd845d52009d1270">Mesh2Dual</a>(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,&amp;ia,&amp;ja);CHKERRQ(ierr);
<a name="l00050"></a>00050     gdata-&gt;mesh2dual_ia=ia;
<a name="l00051"></a>00051     gdata-&gt;mesh2dual_ja=ja;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00054"></a>00054   }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="comment">/* broadcast vertxyz to all processors */</span>
<a name="l00057"></a>00057   ierr = MPI_Bcast(&amp;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,    1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00058"></a>00058   <span class="keywordflow">if</span> (rank) {
<a name="l00059"></a>00059     ierr = PetscMalloc(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>*<span class="keyword">sizeof</span>(PetscReal),&amp;gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>);CHKERRQ(ierr);
<a name="l00060"></a>00060   }
<a name="l00061"></a>00061   ierr = MPI_Bcast(gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,MPIU_SCALAR,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   ierr = MPI_Bcast(&amp;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>,1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00064"></a>00064   <span class="keywordflow">if</span> (rank) {
<a name="l00065"></a>00065     ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>*<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*<span class="keyword">sizeof</span>(PetscReal),&amp;gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>);CHKERRQ(ierr);
<a name="l00066"></a>00066   }
<a name="l00067"></a>00067   ierr = MPI_Bcast(gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>,gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>*<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>,MPIU_SCALAR,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   ierr = MPI_Bcast(&amp;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="preprocessor">#ifdef HAVE_ELEVERTALL</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>  ierr = PetscMalloc(<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;elevertall);CHKERRQ(ierr);
<a name="l00073"></a>00073   <span class="keywordflow">if</span> (!rank) {
<a name="l00074"></a>00074     ierr = PetscMemcpy(gdata-&gt;elevertall,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));CHKERRQ(ierr)
<a name="l00075"></a>00075   }
<a name="l00076"></a>00076   ierr = MPI_Bcast(gdata-&gt;elevertall,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00077"></a>00077 <span class="preprocessor">#ifdef HAVE_M2IJ</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>  <span class="keywordtype">int</span> *ia,*ja;
<a name="l00079"></a>00079   <span class="keywordflow">if</span> (!rank) {
<a name="l00080"></a>00080     ierr = <a class="code" href="mesh2dual_8c.html#abb99aec57817a85ad1c4c2552f695434">Mesh2Nodal</a>(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,&amp;ia,&amp;ja);CHKERRQ(ierr);
<a name="l00081"></a>00081     gdata-&gt;mesh2nodal_ia=ia;
<a name="l00082"></a>00082     gdata-&gt;mesh2nodal_ja=ja;
<a name="l00083"></a>00083 
<a name="l00084"></a>00084     ierr = <a class="code" href="mesh2dual_8c.html#a072403ed5e4bbd16fd845d52009d1270">Mesh2Dual</a>(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,&amp;ia,&amp;ja);CHKERRQ(ierr);
<a name="l00085"></a>00085     gdata-&gt;mesh2dual_ia=ia;
<a name="l00086"></a>00086     gdata-&gt;mesh2dual_ja=ja;
<a name="l00087"></a>00087   }
<a name="l00088"></a>00088   <span class="keywordflow">else</span> {
<a name="l00089"></a>00089     ierr = PetscMalloc((gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>+1)*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;mesh2nodal_ia);CHKERRQ(ierr);
<a name="l00090"></a>00090     ierr = PetscMalloc((gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>+1)*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;mesh2dual_ia);CHKERRQ(ierr);
<a name="l00091"></a>00091   }
<a name="l00092"></a>00092   ierr = MPI_Bcast(gdata-&gt;mesh2nodal_ia,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>+1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00093"></a>00093   ierr = MPI_Bcast(gdata-&gt;mesh2dual_ia,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>+1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="keywordflow">if</span> (rank) {
<a name="l00096"></a>00096     ierr = PetscMalloc(gdata-&gt;mesh2nodal_ia[gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>]*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;mesh2nodal_ja);CHKERRQ(ierr);
<a name="l00097"></a>00097     ierr = PetscMalloc(gdata-&gt;mesh2dual_ia[gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>]*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;mesh2dual_ja);CHKERRQ(ierr);
<a name="l00098"></a>00098   }
<a name="l00099"></a>00099   ierr = MPI_Bcast(gdata-&gt;mesh2nodal_ja,gdata-&gt;mesh2nodal_ia[gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>],MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00100"></a>00100   ierr = MPI_Bcast(gdata-&gt;mesh2dual_ja,gdata-&gt;mesh2dual_ia[gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>],MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00101"></a>00101 <span class="preprocessor">#endif</span>
<a name="l00102"></a>00102 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span>
<a name="l00104"></a>00104   <span class="keywordtype">int</span> t_gotele;
<a name="l00105"></a>00105   t_gotele=<a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>,size,1);
<a name="l00106"></a>00106   <span class="keywordtype">int</span> t_gotn;
<a name="l00107"></a>00107   t_gotn=  <a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#add8d275e857e24934b4873e5746e49b1">eleprop</a>,gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>,1, gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>,size,1);assert(t_gotele==t_gotn);
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <span class="comment">/* distribute boundary faces evenly over processors */</span>
<a name="l00110"></a>00110   ierr = MPI_Bcast(&amp;gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>,1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00111"></a>00111   ierr = MPI_Bcast(&amp;gdata-&gt;<a class="code" href="structGridData.html#a0d57327dd6a657273e24613f3edd7fce">n_bnd_fac</a>, 1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00112"></a>00112   <span class="keywordtype">int</span> *bndfacnewproc;
<a name="l00113"></a>00113   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a0d57327dd6a657273e24613f3edd7fce">n_bnd_fac</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;bndfacnewproc);CHKERRQ(ierr);
<a name="l00114"></a>00114   <span class="keywordflow">if</span> (!rank) {
<a name="l00115"></a>00115     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a0d57327dd6a657273e24613f3edd7fce">n_bnd_fac</a>;i++) {
<a name="l00116"></a>00116       bndfacnewproc[i]=<a class="code" href="distint_8c.html#a42616e8c2899205c9fb1890cf0fb1e7b">distint</a>(gdata-&gt;<a class="code" href="structGridData.html#a0d57327dd6a657273e24613f3edd7fce">n_bnd_fac</a>,size,i);
<a name="l00117"></a>00117     }
<a name="l00118"></a>00118   }
<a name="l00119"></a>00119   <span class="comment">/* cannot move to facnb.c: partsurfser.c needs bndfacvert on proc 0 */</span>
<a name="l00120"></a>00120   <span class="keywordtype">int</span> t_gotbndfac;
<a name="l00121"></a>00121   t_gotbndfac=<a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a018ce7264f478c6eae964c4a753a796b">bndfacvert</a>,gdata-&gt;<a class="code" href="structGridData.html#af59cf93f7a91c270b9f07c2bf2453e25">ln_bnd_fac</a>,<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>,bndfacnewproc,size,1);
<a name="l00122"></a>00122   gdata-&gt;<a class="code" href="structGridData.html#af59cf93f7a91c270b9f07c2bf2453e25">ln_bnd_fac</a>=t_gotbndfac;
<a name="l00123"></a>00123   ierr = PetscFree(bndfacnewproc);CHKERRQ(ierr);
<a name="l00124"></a>00124   PetscSynchronizedPrintf(PETSC_COMM_WORLD,
<a name="l00125"></a>00125     <span class="stringliteral">&quot;&lt;%i&gt;Received local number of boundary faces: %i\n&quot;</span>,
<a name="l00126"></a>00126     rank,gdata-&gt;<a class="code" href="structGridData.html#af59cf93f7a91c270b9f07c2bf2453e25">ln_bnd_fac</a>
<a name="l00127"></a>00127   );
<a name="l00128"></a>00128   PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00129"></a>00129   <span class="keywordtype">int</span> tsum;
<a name="l00130"></a>00130   ierr=MPI_Allreduce((<span class="keywordtype">int</span>*)&amp;gdata-&gt;<a class="code" href="structGridData.html#af59cf93f7a91c270b9f07c2bf2453e25">ln_bnd_fac</a>,(<span class="keywordtype">int</span>*)&amp;tsum,1,MPI_INT,MPI_SUM,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00131"></a>00131   <span class="keywordflow">if</span> (!rank) assert(gdata-&gt;<a class="code" href="structGridData.html#a0d57327dd6a657273e24613f3edd7fce">n_bnd_fac</a>==tsum);
<a name="l00132"></a>00132   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00133"></a>00133     <span class="stringliteral">&quot;Total number of boundary faces: %i\n&quot;</span>,
<a name="l00134"></a>00134     gdata-&gt;<a class="code" href="structGridData.html#a0d57327dd6a657273e24613f3edd7fce">n_bnd_fac</a>
<a name="l00135"></a>00135   );
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="comment">/* Create a global reordering of the element numbers */</span>
<a name="l00138"></a>00138   <span class="keywordtype">int</span> t_gotvert;
<a name="l00139"></a>00139   t_gotvert=<a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>,gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,1,gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>,size,1);
<a name="l00140"></a>00140   t_gotn=<a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a0ea3bd5c6e334d4f8c85dabd70cdf3ee">elel2g</a>,gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>,1,gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>,size,1);assert(t_gotele==t_gotn);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   <span class="comment">/* broadcast all boundary vertex indicators to all processors</span>
<a name="l00143"></a>00143 <span class="comment">     (required for bmatrix)</span>
<a name="l00144"></a>00144 <span class="comment">  */</span>
<a name="l00145"></a>00145   <span class="keywordflow">if</span> (rank) {
<a name="l00146"></a>00146     ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>);CHKERRQ(ierr);
<a name="l00147"></a>00147   }
<a name="l00148"></a>00148   ierr = MPI_Bcast(gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   t_gotn=<a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>,gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,1,gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>,size,1);assert(t_gotvert==t_gotn);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="comment">/* scatter magnetization from the first processor</span>
<a name="l00153"></a>00153 <span class="comment">     into the distributed vector</span>
<a name="l00154"></a>00154 <span class="comment">  */</span>
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   Vec tv_M;
<a name="l00157"></a>00157   ierr = VecCreate(PETSC_COMM_WORLD,&amp;tv_M);CHKERRQ(ierr);
<a name="l00158"></a>00158   ierr = VecSetSizes(tv_M,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*t_gotvert,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>);CHKERRQ(ierr);
<a name="l00159"></a>00159   ierr = VecSetFromOptions(tv_M);CHKERRQ(ierr);
<a name="l00160"></a>00160   ierr = VecSetBlockSize(tv_M,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);CHKERRQ(ierr);
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   IS tis_from,tis_to;
<a name="l00163"></a>00163   <span class="keywordflow">if</span> (!rank) {
<a name="l00164"></a>00164     <span class="comment">/* preserve the ordering since the data have already been permuted above */</span>
<a name="l00165"></a>00165     ierr = ISCreateStride(PETSC_COMM_SELF,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,0,1,&amp;tis_from);CHKERRQ(ierr);
<a name="l00166"></a>00166     ierr = ISCreateStride(PETSC_COMM_SELF,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,0,1,&amp;tis_to);CHKERRQ(ierr);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   }
<a name="l00169"></a>00169   <span class="keywordflow">else</span> {
<a name="l00170"></a>00170     <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a> t_idx_from[1],t_idx_to[1];
<a name="l00171"></a>00171     tis_from=NULL;
<a name="l00172"></a>00172     tis_to=NULL;
<a name="l00173"></a>00173     ISCreateGeneral(PETSC_COMM_SELF,0,t_idx_from,&amp;tis_from);
<a name="l00174"></a>00174     ISCreateGeneral(PETSC_COMM_SELF,0,t_idx_to,  &amp;tis_to);
<a name="l00175"></a>00175   }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   VecScatter t_scatter;
<a name="l00178"></a>00178   VecScatterCreate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,tis_from,tv_M,tis_to,&amp;t_scatter);
<a name="l00179"></a>00179   ISDestroy(tis_from);
<a name="l00180"></a>00180   ISDestroy(tis_to);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   VecScatterBegin(t_scatter,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,tv_M,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00183"></a>00183   VecScatterEnd  (t_scatter,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,tv_M,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00184"></a>00184   VecDestroy(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);
<a name="l00185"></a>00185   gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>=tv_M;
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00188"></a>00188 <span class="preprocessor"></span>  <span class="comment">/* broadcast vertex coupling information to all processors */</span>
<a name="l00189"></a>00189   <span class="keywordtype">int</span> j;
<a name="l00190"></a>00190   <span class="keywordflow">if</span> (!rank) {
<a name="l00191"></a>00191     <span class="keywordflow">if</span> (gdata-&gt;vertcoupl!=PETSC_NULL) {
<a name="l00192"></a>00192       j=1;
<a name="l00193"></a>00193     }
<a name="l00194"></a>00194     <span class="keywordflow">else</span> {
<a name="l00195"></a>00195       j=0;
<a name="l00196"></a>00196     }
<a name="l00197"></a>00197   }
<a name="l00198"></a>00198   ierr = MPI_Bcast(&amp;j,1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   <span class="keywordflow">if</span> (j) {
<a name="l00201"></a>00201     <span class="keywordflow">if</span> (rank) {
<a name="l00202"></a>00202       ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;vertcoupl);CHKERRQ(ierr);
<a name="l00203"></a>00203     }
<a name="l00204"></a>00204 
<a name="l00205"></a>00205     ierr = MPI_Bcast(gdata-&gt;vertcoupl,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00206"></a>00206   }
<a name="l00207"></a>00207   <span class="keywordflow">else</span> {
<a name="l00208"></a>00208     gdata-&gt;vertcoupl=PETSC_NULL;
<a name="l00209"></a>00209   }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <span class="keywordflow">if</span> (gdata-&gt;VH1!=PETSC_NULL) {
<a name="l00212"></a>00212     Vec tv_H1;
<a name="l00213"></a>00213     ierr = VecDuplicate(tv_M,&amp;tv_H1);CHKERRQ(ierr);
<a name="l00214"></a>00214     VecScatterBegin(t_scatter,gdata-&gt;VH1,tv_H1,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00215"></a>00215     VecScatterEnd  (t_scatter,gdata-&gt;VH1,tv_H1,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00216"></a>00216     VecDestroy(gdata-&gt;VH1);
<a name="l00217"></a>00217     gdata-&gt;VH1=tv_H1;
<a name="l00218"></a>00218   }
<a name="l00219"></a>00219   <span class="keywordflow">if</span> (gdata-&gt;VH2!=PETSC_NULL) {
<a name="l00220"></a>00220     Vec tv_H2;
<a name="l00221"></a>00221     ierr = VecDuplicate(tv_M,&amp;tv_H2);CHKERRQ(ierr);
<a name="l00222"></a>00222     VecScatterBegin(t_scatter,gdata-&gt;VH2,tv_H2,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00223"></a>00223     VecScatterEnd  (t_scatter,gdata-&gt;VH2,tv_H2,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00224"></a>00224     VecDestroy(gdata-&gt;VH2);
<a name="l00225"></a>00225     gdata-&gt;VH2=tv_H2;
<a name="l00226"></a>00226   }
<a name="l00227"></a>00227 <span class="preprocessor">#endif</span>
<a name="l00228"></a>00228 <span class="preprocessor"></span>  VecScatterDestroy(t_scatter);
<a name="l00229"></a>00229 
<a name="l00230"></a>00230   t_gotn=<a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>,gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>,1,gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>,size,1);assert(t_gotele==t_gotn);
<a name="l00231"></a>00231   t_gotn=<a class="code" href="ascat_8c.html#ac2f4e1dfdaa7099a74e0603a16a1feb3">ascat</a>(&amp;gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>,gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,1,gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>,size,1);assert(t_gotvert==t_gotn);
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>=t_gotele;
<a name="l00234"></a>00234   gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>=t_gotvert;
<a name="l00235"></a>00235 
<a name="l00236"></a>00236   PetscSynchronizedPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;&lt;%i&gt;Received local number of elements: %i\n&quot;</span>,rank,gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>);
<a name="l00237"></a>00237   PetscSynchronizedPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;&lt;%i&gt;Received local number of vertices: %i\n&quot;</span>,rank,gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>);
<a name="l00238"></a>00238   PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   <span class="comment">/* check correct data transfer */</span>
<a name="l00241"></a>00241   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>; i++)
<a name="l00242"></a>00242   {
<a name="l00243"></a>00243     assert(gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>[i]==rank);
<a name="l00244"></a>00244   }
<a name="l00245"></a>00245   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; i++)
<a name="l00246"></a>00246   {
<a name="l00247"></a>00247     assert(gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>[i]==rank);
<a name="l00248"></a>00248   }
<a name="l00249"></a>00249   PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   <span class="keywordtype">int</span> vidlow, vidhigh, vlocsize;
<a name="l00252"></a>00252   ierr = VecGetOwnershipRange(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;vidlow,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;vidhigh);CHKERRQ(ierr);
<a name="l00253"></a>00253   ierr = VecGetLocalSize(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;vlocsize);CHKERRQ(ierr);
<a name="l00254"></a>00254   vidlow   /= <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00255"></a>00255   vidhigh  /= <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00256"></a>00256   vlocsize /= <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00257"></a>00257   assert(vidhigh-vidlow==vlocsize);
<a name="l00258"></a>00258   assert(vlocsize==gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>);
<a name="l00259"></a>00259   PetscSynchronizedPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;&lt;%i&gt;Ownership(M): from vertex id %i to vertex id %i\n&quot;</span>,rank,vidlow,vidhigh-1);
<a name="l00260"></a>00260   PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   ierr = PetscFree(gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>);CHKERRQ(ierr);
<a name="l00263"></a>00263   gdata-&gt;<a class="code" href="structGridData.html#a81f9058aeac41c1da988bdd8ca96ad6f">vertnewproc</a>=PETSC_NULL;
<a name="l00264"></a>00264   ierr = PetscFree(gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>);CHKERRQ(ierr);
<a name="l00265"></a>00265   gdata-&gt;<a class="code" href="structGridData.html#a3d5ee63a7e1af8e60963b7e051b543a3">elenewproc</a>=PETSC_NULL;
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00268"></a>00268 }
<a name="l00269"></a>00269 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

